"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenObjectKeys = exports.get = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var get = function get(obj, path, def) {
  var stringToPath = function stringToPath(pathValue) {
    if (typeof pathValue !== 'string') {
      return pathValue;
    }

    var output = [];
    pathValue.split('.').forEach(function (item) {
      item.split(/\[([^}]+)\]/g).forEach(function (key) {
        if (key.length > 0) {
          output.push(key);
        }
      });
    });
    return output;
  };

  var findPath = stringToPath(path);
  var current = obj;

  for (var i = 0; i < findPath.length; i++) {
    if (!current[findPath[i]]) {
      return def;
    }

    current = current[findPath[i]];
  }

  return current;
};

exports.get = get;

var flattenObjectKeys = function flattenObjectKeys(obj) {
  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var flatObjectProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  Object.keys(obj).reduce(function (acc, k) {
    var pre = prefix.length ? "".concat(prefix, ".") : '';

    if (_typeof(obj[k]) === 'object') {
      Object.assign(acc, flattenObjectKeys(obj[k], pre + k, flatObjectProps));
    } else {
      flatObjectProps.push(pre + k);
    }

    return acc;
  }, {});
  return flatObjectProps;
};

exports.flattenObjectKeys = flattenObjectKeys;